/* 
  Anveo Delta Server Uninstallation
  Version 3  February 4, 2016

  Do a full SQL backup before using this script. No warranties for data loss.
*/

/*Drop all Anveo Procedures*/
	PRINT ('Deleting Procedures...');

	IF (EXISTS(SELECT * WHERE DB_NAME() IN ('master', 'model', 'tempdb', 'msdb')))
		BEGIN
			RAISERROR ('Wrong DataBase', 16,1) WITH SETERROR;
			RETURN;
		END;

	IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[UDP_Server_Setup_ANVEODELTA]') AND type in (N'P', N'PC'))
		DROP PROCEDURE [dbo].[UDP_Server_Setup_ANVEODELTA]
	GO

	IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[UDP_Packg_Setup_ANVEODELTA]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[UDP_Packg_Setup_ANVEODELTA]
	GO

	IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[UDP_Uninstall_ANVEODELTA]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[UDP_Uninstall_ANVEODELTA]
	GO

	IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[UDP_Build_ANVEODELTA]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[UDP_Build_ANVEODELTA]
	GO

	IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[UDP_Clear_ANVEODATA_Tables_ACFAnveoUserDevice]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[UDP_Clear_ANVEODATA_Tables_ACFAnveoUserDevice]
	GO

	IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[UDP_ClearTables_AnveoUserDevice]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[UDP_ClearTables_AnveoUserDevice]
	GO

	IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[UDP_Execute_SQL_Script_ANVEODELTA]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[UDP_Execute_SQL_Script_ANVEODELTA]
	GO

	IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[UDP_GetVersion]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[UDP_GetVersion]
	GO

	IF  EXISTS (SELECT * FROM sys.assemblies asms WHERE asms.name = N'Anveo_Delta_Server')
		DROP ASSEMBLY [Anveo_Delta_Server]
	GO

	DECLARE @ProcedureId VARCHAR(255);
	DECLARE @dropProcedureCommand VARCHAR(255) ;

	DECLARE tableCursor CURSOR FOR 
		SELECT sobjects.name FROM sysobjects sobjects WHERE sobjects.xtype = 'PC' AND NAME LIKE '%_ANVEO%';

	OPEN tableCursor 
	FETCH NEXT FROM tableCursor INTO @ProcedureId 

	WHILE @@fetch_status=0 
	BEGIN 
		SET @dropProcedureCommand = N'DROP PROCEDURE [dbo].[' + @ProcedureId  + ']'
		EXECUTE(@dropProcedureCommand);
		FETCH NEXT FROM tableCursor INTO @ProcedureId 
	END 

	CLOSE tableCursor 
	DEALLOCATE tableCursor
    PRINT ('Procedures deleted.');

/*Drop all Anveo Triggers*/
	PRINT ('Deleting triggers...');
	DECLARE @TriggerId VARCHAR(255);
	DECLARE @dropTriggerCommand VARCHAR(255) ;

	DECLARE tableCursor CURSOR FOR
			SELECT sobjects.name FROM sysobjects sobjects WHERE sobjects.xtype = 'TR' AND NAME LIKE '%_ANVEO%';

	OPEN tableCursor 
	FETCH NEXT FROM tableCursor INTO @TriggerId

	WHILE @@fetch_status=0 
	BEGIN 
			SET @dropTriggerCommand = N'DROP TRIGGER [dbo].[' + @TriggerId  + ']'
			EXECUTE(@dropTriggerCommand);
			FETCH NEXT FROM tableCursor INTO @TriggerId
	END 

	CLOSE tableCursor 
	DEALLOCATE tableCursor
	PRINT ('Triggers deleted.');

/*Drop all _ANVEODELTA and _ANVEODATA Tables*/
	PRINT ('Deleting ANVEODELTA and ANVEODATA tables...');
	DECLARE @tableId VARCHAR(255);
	DECLARE @dropTableCommand VARCHAR(255) ;
	DECLARE tableCursor CURSOR FOR 
		SELECT sobjects.name FROM sysobjects sobjects WHERE sobjects.xtype = 'U' AND NAME LIKE '%_ANVEODELTA' OR NAME LIKE '%_ANVEODATA'

	OPEN tableCursor 
	FETCH NEXT FROM tableCursor INTO @tableId 

	WHILE @@fetch_status=0 
	BEGIN 
		SET @dropTableCommand = N'DROP TABLE [dbo].[' + @tableId  + ']'
		EXECUTE(@dropTableCommand);
		FETCH NEXT FROM tableCursor INTO @tableId 
	END 

	CLOSE tableCursor 
	DEALLOCATE tableCursor
	PRINT ('Tables deleted.');

PRINT ('Uninstallation done.');